import{s as we,n as Ce,o as Pe}from"../chunks/scheduler.182ea377.js";import{S as Oe,i as ke,g as a,s as o,r as f,A as Ee,h as d,f as t,c as i,j as D,u as m,x as T,k as H,y as s,a as l,v as h,d as g,t as _,w as v}from"../chunks/index.abf12888.js";import{D as j}from"../chunks/Docstring.93f6f462.js";import{H as _e}from"../chunks/Heading.16916d63.js";function Le(ve){let u,R,K,W,y,G,w,be='The Heun scheduler (Algorithm 1) is from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper by Karras et al. The scheduler is ported from the <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">k-diffusion</a> library and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',J,C,Q,r,P,ie,F,xe="Scheduler with Heun steps for discrete beta schedules.",ae,I,$e=`This model inherits from <a href="/docs/diffusers/v0.27.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.27.0/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,de,b,O,ce,V,Se=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,le,x,k,ue,U,De="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",pe,$,E,fe,A,Te="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",me,S,L,he,N,He=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,X,M,Y,p,q,ge,z,ye="Base class for the output of a scheduler’s <code>step</code> function.",Z,B,ee;return y=new _e({props:{title:"HeunDiscreteScheduler",local:"heundiscretescheduler",headingTag:"h1"}}),C=new _e({props:{title:"HeunDiscreteScheduler",local:"diffusers.HeunDiscreteScheduler",headingTag:"h2"}}),P=new j({props:{name:"class diffusers.HeunDiscreteScheduler",anchor:"diffusers.HeunDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"clip_sample",val:": Optional = False"},{name:"clip_sample_range",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.HeunDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.HeunDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.HeunDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.HeunDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.HeunDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.HeunDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.HeunDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.HeunDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/v0.27.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L70"}}),O=new j({props:{name:"scale_model_input",anchor:"diffusers.HeunDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/v0.27.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L199",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.FloatTensor</code></p>
`}}),k=new j({props:{name:"set_begin_index",anchor:"diffusers.HeunDiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/v0.27.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L189"}}),E=new j({props:{name:"set_timesteps",anchor:"diffusers.HeunDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/v0.27.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L225"}}),L=new j({props:{name:"step",anchor:"diffusers.HeunDiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.HeunDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.HeunDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.27.0/en/api/schedulers/overview#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.27.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L352",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/v0.27.0/en/api/schedulers/overview#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/v0.27.0/en/api/schedulers/overview#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),M=new _e({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),q=new j({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.27.0/src/diffusers/schedulers/scheduling_utils.py#L51"}}),{c(){u=a("meta"),R=o(),K=a("p"),W=o(),f(y.$$.fragment),G=o(),w=a("p"),w.innerHTML=be,J=o(),f(C.$$.fragment),Q=o(),r=a("div"),f(P.$$.fragment),ie=o(),F=a("p"),F.textContent=xe,ae=o(),I=a("p"),I.innerHTML=$e,de=o(),b=a("div"),f(O.$$.fragment),ce=o(),V=a("p"),V.textContent=Se,le=o(),x=a("div"),f(k.$$.fragment),ue=o(),U=a("p"),U.textContent=De,pe=o(),$=a("div"),f(E.$$.fragment),fe=o(),A=a("p"),A.textContent=Te,me=o(),S=a("div"),f(L.$$.fragment),he=o(),N=a("p"),N.textContent=He,X=o(),f(M.$$.fragment),Y=o(),p=a("div"),f(q.$$.fragment),ge=o(),z=a("p"),z.innerHTML=ye,Z=o(),B=a("p"),this.h()},l(e){const n=Ee("svelte-u9bgzb",document.head);u=d(n,"META",{name:!0,content:!0}),n.forEach(t),R=i(e),K=d(e,"P",{}),D(K).forEach(t),W=i(e),m(y.$$.fragment,e),G=i(e),w=d(e,"P",{"data-svelte-h":!0}),T(w)!=="svelte-1r9m54f"&&(w.innerHTML=be),J=i(e),m(C.$$.fragment,e),Q=i(e),r=d(e,"DIV",{class:!0});var c=D(r);m(P.$$.fragment,c),ie=i(c),F=d(c,"P",{"data-svelte-h":!0}),T(F)!=="svelte-1k165jq"&&(F.textContent=xe),ae=i(c),I=d(c,"P",{"data-svelte-h":!0}),T(I)!=="svelte-15wg2qx"&&(I.innerHTML=$e),de=i(c),b=d(c,"DIV",{class:!0});var te=D(b);m(O.$$.fragment,te),ce=i(te),V=d(te,"P",{"data-svelte-h":!0}),T(V)!=="svelte-1rkfgpx"&&(V.textContent=Se),te.forEach(t),le=i(c),x=d(c,"DIV",{class:!0});var se=D(x);m(k.$$.fragment,se),ue=i(se),U=d(se,"P",{"data-svelte-h":!0}),T(U)!=="svelte-1k141rk"&&(U.textContent=De),se.forEach(t),pe=i(c),$=d(c,"DIV",{class:!0});var re=D($);m(E.$$.fragment,re),fe=i(re),A=d(re,"P",{"data-svelte-h":!0}),T(A)!=="svelte-1vzm9q"&&(A.textContent=Te),re.forEach(t),me=i(c),S=d(c,"DIV",{class:!0});var ne=D(S);m(L.$$.fragment,ne),he=i(ne),N=d(ne,"P",{"data-svelte-h":!0}),T(N)!=="svelte-hi84tp"&&(N.textContent=He),ne.forEach(t),c.forEach(t),X=i(e),m(M.$$.fragment,e),Y=i(e),p=d(e,"DIV",{class:!0});var oe=D(p);m(q.$$.fragment,oe),ge=i(oe),z=d(oe,"P",{"data-svelte-h":!0}),T(z)!=="svelte-6ojmkw"&&(z.innerHTML=ye),oe.forEach(t),Z=i(e),B=d(e,"P",{}),D(B).forEach(t),this.h()},h(){H(u,"name","hf:doc:metadata"),H(u,"content",Me),H(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),H(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){s(document.head,u),l(e,R,n),l(e,K,n),l(e,W,n),h(y,e,n),l(e,G,n),l(e,w,n),l(e,J,n),h(C,e,n),l(e,Q,n),l(e,r,n),h(P,r,null),s(r,ie),s(r,F),s(r,ae),s(r,I),s(r,de),s(r,b),h(O,b,null),s(b,ce),s(b,V),s(r,le),s(r,x),h(k,x,null),s(x,ue),s(x,U),s(r,pe),s(r,$),h(E,$,null),s($,fe),s($,A),s(r,me),s(r,S),h(L,S,null),s(S,he),s(S,N),l(e,X,n),h(M,e,n),l(e,Y,n),l(e,p,n),h(q,p,null),s(p,ge),s(p,z),l(e,Z,n),l(e,B,n),ee=!0},p:Ce,i(e){ee||(g(y.$$.fragment,e),g(C.$$.fragment,e),g(P.$$.fragment,e),g(O.$$.fragment,e),g(k.$$.fragment,e),g(E.$$.fragment,e),g(L.$$.fragment,e),g(M.$$.fragment,e),g(q.$$.fragment,e),ee=!0)},o(e){_(y.$$.fragment,e),_(C.$$.fragment,e),_(P.$$.fragment,e),_(O.$$.fragment,e),_(k.$$.fragment,e),_(E.$$.fragment,e),_(L.$$.fragment,e),_(M.$$.fragment,e),_(q.$$.fragment,e),ee=!1},d(e){e&&(t(R),t(K),t(W),t(G),t(w),t(J),t(Q),t(r),t(X),t(Y),t(p),t(Z),t(B)),t(u),v(y,e),v(C,e),v(P),v(O),v(k),v(E),v(L),v(M,e),v(q)}}}const Me='{"title":"HeunDiscreteScheduler","local":"heundiscretescheduler","sections":[{"title":"HeunDiscreteScheduler","local":"diffusers.HeunDiscreteScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function qe(ve){return Pe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ae extends Oe{constructor(u){super(),ke(this,u,qe,Le,we,{})}}export{Ae as component};
